package cs;

public class ExceptionHandler {

	public static int RETRY_COUNT = 5;

	public interface Handler<T> {
		public T handle() throws Exception;
	}

	public static <T extends Object> T retry(final Handler<T> handler) throws Exception {
		T result = null;
		for (int i = 1; i <= RETRY_COUNT; i++) {
			try {
				result = handler.handle();
				break;
			} catch (Exception e) {
				if (RETRY_COUNT == i) {
					throw e;
				} else {
					String causePoint = null;
					for (StackTraceElement ste : e.getStackTrace()) {
						if (ste.getClassName().startsWith("cs.")) {
							causePoint = ste.toString();
							break;
						}
					}
					System.err.printf("Worry & Retry!(%d of %d) [%s]%s Message: %s\n", i,
							RETRY_COUNT,
							causePoint,
							e.getClass().getName(),
							e.getLocalizedMessage());
				}
			}
		}
		return result;
	}
}
